<?php
/*	simple_folder : page folder
	name : simple_folder
	author: team1/3
*/

	global $params,$config;

	if (!isset($config)) { die(); }
	
	draw();
	
	$params['rendering'] = false;

function draw()
{
	global $html,$params,$database,$ut;
	
	$page_ar = &$params['page'];
	$p_page = $page_ar['id'];

	if (check_rights('owner')) {
		set_func_right('edit.modules');
		set_func_right('add_page');
		provide_edit_rights();
		provide_edit_module();
	}

	if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
		// 編集
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Page Edit');
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);
		return;

	} else if (isset($_GET['mode']) && $_GET['mode']=='format') {
		// format編集
		$params['hook']['before_modified'][] = 'my_page_folder_onbefore_modified';
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Format Edit');

		$params['hide-editmenu'] = true;
$params['add-editmenu'][] = <<<EOT
		<input type='button' onclick='ot.save_editdata(1)' class='onethird-button mini'  value='save' />
		<input type='button' onclick='ot.open_uploader({select:function(obj){ot.editor.insertimg(obj)}})' class='onethird-button mini' value='image' />
EOT;
		if (isset($page_ar['meta']['format'])) {
			$page_ar['contents'] = $page_ar['meta']['format'];
		} else {
			$page_ar['contents'] = '';
		}
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);

	} else {
		// 通常表示
		snippet_breadcrumb($page_ar['link'], $page_ar['title']);
		write_page_folder($page_ar);
	}
}

function my_page_folder_onbefore_modified( &$new_ar )
{
	global $params,$config,$ut;

	if (isset($_GET['mode']) && $_GET['mode'] != 'format') {
		return;
	}
	
	//フォーマットの保存処理
	$new_ar['meta']['format'] = $new_ar['contents'];
	$new_ar['metadata'] = serialize64($new_ar['meta']);
	unset($new_ar['meta']);
	unset($new_ar['contents']);
	if (!mod_data_items($new_ar)) {
		if (isset($_POST['ajax'])) {
			echo( json_encode($r) );
			exit();
		}
		exit_proc(400, 'Save-Error');

	} else {

		if ($new_ar['type'] >= 10) {
			event_plugin_page('onmodified', $new_ar);
		}
		
		if (isset($r['url'])) {
			header("Location: {$r['url']}");
		
		} else {
			if ($new_ar['block_type'] == 5) {
				header("Location: {$ut->link($new_ar['link'])}");
			} else {
				header("Location: {$ut->link($new_ar['id'])}");
			}
		}
		
		exit();
	}
}

function write_page_folder( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar;

	$id = $page_ar['id'];
	$parent_page = $page_ar['id'];		//自ページが親ページ

	$add_type = 1;
	$hide_addbtn = false;
	$allow_post = !empty($page_ar['meta']['page_folder_allow_post']) && check_rights();
	
	$ar = $database->sql_select_all("select id,metadata from ".DBX."data_items where type=? and id=? ", $page_ar['type'], $id);
	if ($ar) {
		$m = unserialize64($ar[0]['metadata']);
	}

	if ($allow_post) {
		set_func_right('add_data_items');
		provide_edit_rights();
	}

	if ($allow_post || isset($params['edit-right']) || check_rights('edit')) {
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'plugin_my_page_folder_make_page')  {
			$r = array();
			$r['link'] = (int)$_POST['page'];
			$r['result'] = false;
			
			if (empty($_POST['type'])) {
				echo( json_encode($r) );
				exit();
			}
			$r['type'] = (int)($_POST['type']);
			if ($r['type'] == PAGE_FOLDER_ID) {
				$r['title'] = 'Folder';
				$r['block_type'] = 1;
				$r['mode'] = 1;
				if (isset($page_ar['meta']['format'])) {
					$r['meta']['format'] = $page_ar['meta']['format'];
				}
				if ($allow_post) {
					$r['meta']['page_folder_allow_post'] = true;
				}
			} else {
				if (isset($page_ar['meta']['format'])) {
					$r['contents'] = $page_ar['meta']['format'];
				}
				if (!check_right('edit') && $allow_post) {
					// edit権限なして追加できるページはトピックページのみ
					// itemをlwerに引き継がないので必要
					$r['type'] = TOPIC_ITEM_ID;		
				}
			}
			create_page( $r );
			if ($r['type'] == PAGE_FOLDER_ID && isset($r['open_url'])) {
				unset($r['open_url']);
			}
			echo( json_encode($r) );
			exit();
		}
		if (!isset($html['meta']['plugin_my_page_folder_make_page'])) {
$html['meta']['plugin_my_page_folder_make_page'] = <<<EOT
			<script>
			ot.plugin_my_page_folder_make_page = function (link,type) {
				var opt = "ajax=plugin_my_page_folder_make_page";
				opt += "&type="+type+"&page="+link;
				ot.ajax({
					type: "POST"
					, url: '{$_SERVER['REQUEST_URI']}'
					, data: opt
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
							if ( data['open_url'] ) {
								location.href = data['open_url'];
							} else {
								location.reload(true);
							}
						} else {
							alert('Failure to create a page.');
						}
					}
				});
			};
			</script>
EOT;
		}
	}

$params['add-blockmenu'][] = <<<EOT
	<a href='{$ut->link($page_ar['id'],'&:mode=format')}' class='onethird-button mini'>format</a>
	<a href='javascript:void(ot.page_folder_setting())' class='onethird-button mini'>Setting</a>
EOT;
	$html['article'][] = frame_renderer(body_renderer($page_ar));	// 通常ページ部分

	$arg = array('id'=>$parent_page);
	$buff = my_page_folder($arg);
	
	if (!$hide_addbtn && ($allow_post || check_rights('edit'))) {
		$folder_type = PAGE_FOLDER_ID;
$buff .= <<<EOT
		<p class='add-panel'>
			<input type='button' value='Add page' class='onethird-button mini' onclick='ot.plugin_my_page_folder_make_page({$parent_page}, $add_type)' />
			<input type='button' value='Add folder' class='onethird-button mini' onclick='ot.plugin_my_page_folder_make_page({$parent_page}, $folder_type)' />
		</p>
EOT;
		
	}
	$html['article'][] = frame_renderer($buff,'plugin-page-folder-unit');

	if (!isset($html['head']['plugin-page-folder'])) {
$html['head']['plugin-page-folder'] = <<<EOT
		<style>
			.plugin-page-folder-unit {
				margin-bottom:10px;
			}
			.plugin-page-folder-unit p {
				margin:0 0 5px 0;
				padding:0;
			}
			.plugin-page-folder-unit .title {
				color: #286593;
				font-size: 20px;
				margin:0 0 5px 0;
			}
			.plugin-page-folder-unit .onethird-button {
				margin-top:10px;
			}
			.plugin-page-folder-unit .add-panel {
				margin:15px 0 15px 0;
			}
			.plugin-page-folder-unit img {
				vertical-align: middle;
			}
			.plugin-page-folder-unit p .date {
				color:#A0A0A0;
				font-size:90%;
			}
			.plugin-page-folder-unit p .new {
				color:#FF7000;
				padding:0 5px;
			}
		</style>
EOT;
	}

	
	$html['article'][] = innerpage_renderer($page_ar['id']);

	// 設定
	if (check_rights('edit')) {
		snippet_std_setting("Setting","page_folder_setting");
		if (isset($_POST['ajax']) && $_POST['ajax'] == "page_folder_setting")  {
			$r = array();
			$r['result'] = true;
			$r['id'] = $p_id = $params['page']['id'];
			$r['meta'] = $params['page']['meta'];
$r['html'] = <<<EOT
			<table>
				<tr>
					<td style='vertical-align: top;'>Option</td>
					<td>
						<ul class="inputs-list">
							<li><label>
								<input type='checkbox' data-input='page_folder_allow_post' 
									{$ut->check(!empty($r['meta']['page_folder_allow_post']),'checked')}/> 
									Allow All Users to Submit Posts
								</label>
							</li>
						<ul>
					</td>
				</tr>
			</table>
EOT;
			echo(json_encode($r));
			exit();
		}

		if (check_rights('edit') && isset($_POST['ajax']) && $_POST['ajax'] == 'save_page_folder_setting')  {

			$r = array();
			$r['result'] = false;
			$r['id'] = $params['page']['id'];
			$r['meta'] = $params['page']['meta'];
			$r['meta']['acc_ctrl'] = array();
			if (isset($_POST['page_folder_allow_post'])) {
				$r['meta']['page_folder_allow_post'] = true;
			} else {
				$r['meta']['page_folder_allow_post'] = false;
			}
			if (mod_data_items($r)) {
				$r['result'] = true;
			}

			echo(json_encode($r));
			exit();
		}
	}

	return;
}


function my_page_folder( &$arg )
{
	global $params, $ut, $database, $html;


	// 表示
	$option = array();
	$option['total'] = 0;
	$option['offset'] = 0;
	$option['page_size'] = 50;

	$type = 0;
	$offset_name = 'offset';
	$id = $params['page']['id'];
	if (isset($arg['id'])) {
		$id = $arg['id'];
	}
	if (isset($arg['type'])) {
		$type = $arg['type'];
	}
	if (isset($arg['offset_name'])) {
		$offset_name = $arg['offset_name'];
	}
	$option['offset_name'] = $offset_name;
	
	$opt = ' and mode<>2 ';
	if (!check_rights()) {
		$opt = ' and mode=1 ';
	} else if (!check_rights()) {
		$opt = ' and (mode=1 or (mode=0 and user='.(int)($_SESSION['login_id']).' ';
	}

	$ar = $database->sql_select_all("select count(id) as c from ".DBX."data_items where link=? and block_type !=5 $opt", $id);
	if ($ar) {
		$option['total'] = $ar[0]['c'];
	}
	if (isset($_GET[$offset_name])) {
		$option['offset'] = (int)$_GET[$offset_name];
	}
	if (isset($arg['page_size'])) {
		$option['page_size'] = (int)$arg['page_size'];
	}

	$order = 'order by date desc';
	//$order = 'order by date asc';
	
	$buff = '';

	// write foloder
	$sql = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql .= " where link=? and block_type !=5";
	$sql .= " and type=".PAGE_FOLDER_ID;
	$sql .= " $opt $order";
	$folder_ar = $database->sql_select_all($sql, $id);

	// write page
	$sql = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql .= " where link=? and block_type !=5";
	if ($type) {
		$sql .= " and type={$type} ";
	} else {
		$sql .= " and type <>".PAGE_FOLDER_ID;
	}
	$sql .= " $opt $order";
	$sql .= " {$ut->limit($option['offset']*$option['page_size'], $option['page_size'])} ";
	
	$ar = $database->sql_select_all($sql, $id);
	$ar = array_merge($folder_ar,$ar);
	$buff .= my_page_folder_writer($ar);
	$buff = std_pagination_renderer( $option ).$buff;

	return $buff;
}

function my_page_folder_writer( &$ar )
{
	global $ut,$html,$config,$params;

	$buff = '';
	$nt = time();
	foreach ($ar as $v) {
		$t = $v['title'];
		$ico = '';
		if (!$t) { $t = '...'; }
		$u = $ut->link($v['id']);
		if ($v['type'] == PAGE_FOLDER_ID) {
			$ico = $ut->icon('folder',"width='16'");
		}
		if ($v['mode'] == 0) {
			if (!check_rights('edit') && isset($_SESSION['login_id']) && $v['user'] != $_SESSION['login_id']) { continue; }
			$t = $t.$ut->icon('lock','width="16"');
		}
		$d = substr($v['date'],0,10);
$buff .= <<<EOT
		<p id='plugin_page_folder{$v['id']}' >
			{$ico} <a href='{$ut->link($v['id'])}'>{$t}</a> <span class='date'>{$d}</span>
		</p>
EOT;
	}

	return $buff;
}


?>